# Speed Bar
# 1.13.x [Boyrex Macaraya]

# {setup}
gamerule commandBlockOutput false
gamerule sendCommandFeedback false
gamerule logAdminCommands false
gamerule disableElytraMovementCheck true

scoreboard objectives add walkOneCm minecraft.custom:minecraft.walk_one_cm
scoreboard objectives add sprintOneCm minecraft.custom:minecraft.sprint_one_cm
scoreboard objectives add crouchOneCm minecraft.custom:minecraft.crouch_one_cm
scoreboard objectives add deathCount deathCount
scoreboard objectives add speedBar dummy
scoreboard objectives add motion dummy
scoreboard objectives add oneCm dummy

# {gameplay}
execute as @a at @s if entity @s run title @s actionbar ["",{"text":"Speed: ","color":"aqua","bold":"true"},{"score":{"name":"@s","objective":"speedBar"}}]
execute as @a at @s if entity @s run effect clear @s jump_boost
execute as @a at @s if entity @s run effect clear @s slowness
execute as @a at @s if entity @s run effect clear @s speed

execute as @a[advancements={game:128_cm=false}] at @s if entity @s if score @s oneCm matches 128.. run advancement grant @s only game:128_cm
execute as @a[advancements={game:256_cm=false}] at @s if entity @s if score @s oneCm matches 256.. run advancement grant @s only game:256_cm
execute as @a[advancements={game:512_cm=false}] at @s if entity @s if score @s oneCm matches 512.. run advancement grant @s only game:512_cm

execute as @a at @s if entity @s if score @s walkOneCm matches 1.. run scoreboard players add @s motion 1
execute as @a at @s if entity @s if score @s sprintOneCm matches 1.. run scoreboard players add @s motion 1
execute as @a at @s if entity @s if score @s crouchOneCm matches 1.. run scoreboard players add @s motion 1
execute as @a at @s if entity @s if score @s motion matches 1.. run scoreboard players add @s oneCm 1

execute as @a at @s if entity @s if score @s oneCm matches 1024.. unless score @s speedBar matches ..-5 run advancement grant @s only game:slowness
execute as @a at @s if entity @s if score @s oneCm matches 1024.. unless score @s speedBar matches ..-5 run playsound entity.experience_orb.pickup player @s ~ ~ ~ 100 0.5
execute as @a at @s if entity @s if score @s oneCm matches 1024.. unless score @s speedBar matches ..-5 run scoreboard players remove @s speedBar 1
execute as @a at @s if entity @s if score @s oneCm matches 1024.. unless score @s speedBar matches ..-5 run scoreboard players set @s oneCm 512

execute as @a at @s if entity @s if score @s oneCm matches ..0 unless score @s speedBar matches 5.. run advancement grant @s only game:speed
execute as @a at @s if entity @s if score @s oneCm matches ..0 unless score @s speedBar matches 5.. run playsound entity.experience_orb.pickup player @s ~ ~ ~ 100 2
execute as @a at @s if entity @s if score @s oneCm matches ..0 unless score @s speedBar matches 5.. run scoreboard players add @s speedBar 1
execute as @a at @s if entity @s if score @s oneCm matches ..0 unless score @s speedBar matches 5.. run scoreboard players set @s oneCm 512

execute as @a at @s if entity @s if score @s oneCm matches ..-1 if score @s speedBar matches 5.. run scoreboard players add @s oneCm 256

execute as @a at @s if entity @s if score @s speedBar matches -1 run effect give @s slowness 1 0 true
execute as @a at @s if entity @s if score @s speedBar matches -2 run effect give @s slowness 1 1 true
execute as @a at @s if entity @s if score @s speedBar matches -3 run effect give @s slowness 1 2 true
execute as @a at @s if entity @s if score @s speedBar matches -4 run effect give @s slowness 1 3 true
execute as @a at @s if entity @s if score @s speedBar matches ..-5 run effect give @s slowness 1 4 true

execute as @a at @s if entity @s if score @s speedBar matches -1 run effect give @s jump_boost 1 254 true
execute as @a at @s if entity @s if score @s speedBar matches -2 run effect give @s jump_boost 1 253 true
execute as @a at @s if entity @s if score @s speedBar matches -3 run effect give @s jump_boost 1 252 true
execute as @a at @s if entity @s if score @s speedBar matches -4 run effect give @s jump_boost 1 251 true
execute as @a at @s if entity @s if score @s speedBar matches ..-5 run effect give @s jump_boost 1 250 true

execute as @a at @s if entity @s if score @s speedBar matches 1 run effect give @s speed 1 0 true
execute as @a at @s if entity @s if score @s speedBar matches 2 run effect give @s speed 1 1 true
execute as @a at @s if entity @s if score @s speedBar matches 3 run effect give @s speed 1 2 true
execute as @a at @s if entity @s if score @s speedBar matches 4 run effect give @s speed 1 3 true
execute as @a at @s if entity @s if score @s speedBar matches 5.. run effect give @s speed 1 4 true

execute as @a at @s if entity @s if score @s speedBar matches 1 run effect give @s jump_boost 1 0 true
execute as @a at @s if entity @s if score @s speedBar matches 2 run effect give @s jump_boost 1 1 true
execute as @a at @s if entity @s if score @s speedBar matches 3 run effect give @s jump_boost 1 2 true
execute as @a at @s if entity @s if score @s speedBar matches 4 run effect give @s jump_boost 1 3 true
execute as @a at @s if entity @s if score @s speedBar matches 5.. run effect give @s jump_boost 1 4 true

execute as @a at @s if entity @s if score @s deathCount matches 1.. run scoreboard players reset @s oneCm
execute as @a at @s if entity @s if score @s deathCount matches 1.. run scoreboard players set @s speedBar 0

# {reset}
advancement revoke @a only game:eat_item

scoreboard players reset @a walkOneCm
scoreboard players reset @a sprintOneCm
scoreboard players reset @a crouchOneCm
scoreboard players reset @a deathCount
scoreboard players reset @a motion